/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/lib/cvs/xdautils/common/debug.h,v 1.9 2004/09/27 17:01:24 itsme Exp $
 */
#ifndef __DEBUG_H__

#include <windows.h>	// for DWORD and BYTE
#include <TCHAR.h>
#include <string>
#include "vectorutils.h"

void debug(const char *msg, ...);
void error(const char *msg, ...);
void ceerror(const char *msg, ...);
void error(DWORD dwErrorCode, const char *msg, ...);
void debugt(char *msg, ...);

class CDebugWindow  {
public:
    virtual void appendString(const TCHAR *str)=0;
};

void DebugSetLogfile(const char *filename);
void DebugRegisterWindow(CDebugWindow *wnd);
void DebugMessagebox();
void DebugOutputDebugString();
void DebugStdOut();

enum DumpUnitType {
    DUMPUNIT_BYTE=0,
    DUMPUNIT_WORD=1,
    DUMPUNIT_DWORD=2
};
inline DumpUnitSize(DumpUnitType type) { return 1<<type; }

enum DumpFormat {
    DUMP_HEX_ASCII,     // [offset] 50 51 52 53 0d 0a 00 01  PQRS....
    DUMP_HEX,           // [offset] 50 51 52 53 0d 0a 00 01
    DUMP_ASCII,         // [offset] PQRS....
    DUMP_STRINGS,       // [offset] "PQRS",0d,0a,00,01
    DUMP_RAW            // [offset] PQRS^M^J^@^A
};
#define HEXDUMP_WITH_OFFSET    (1<<16)
#define HEXDUMP_SUMMARIZE      (1<<17)
#define HEXDUMP_MOREFOLLOWS    (1<<18)

inline DWORD hexdumpflags(DumpUnitType unit, int units_per_line, DumpFormat format) {
    return units_per_line | (unit<<8) | (format<<12);
}
inline DumpUnitType dumpunit_from_flags(DWORD flags) { return (DumpUnitType) ((flags>>8)&3); }
inline DumpFormat dumpformat_from_flags(DWORD flags) { return (DumpFormat) ((flags>>12)&15); }
inline int unitsperline_from_flags(DWORD flags) { return flags&255; }

void bighexdump(DWORD dwOffset, const ByteVector& data, DWORD flags=hexdumpflags(DUMPUNIT_BYTE, 16, DUMP_HEX_ASCII)|HEXDUMP_WITH_OFFSET|HEXDUMP_SUMMARIZE);
void bighexdump(const ByteVector& data, DWORD flags=hexdumpflags(DUMPUNIT_BYTE, 16, DUMP_HEX_ASCII)|HEXDUMP_SUMMARIZE);

#define __DEBUG_H__
#endif

