/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/lib/cvs/xdautils/common/stringutils.h,v 1.4 2004/07/08 13:35:52 itsme Exp $
 */
#ifndef __STRINGUTILS_H_

// make sure everything is compiled with '_MT' defined.
// otherwise this will not link with code that has any of the mfc
// headers included.
//    without _MT this code compiles to non multithreaded templates,
//    with it compiles to templates with threading support.

#include <tchar.h>

#include <string>
#include <vector>
#include "vectorutils.h"

typedef std::vector<std::string> StringList;

std::string ToString(TCHAR* tbuf);
std::wstring ToWString(TCHAR* tbuf);
std::string ToString(char* buf);
std::wstring ToWString(char* buf);
std::string ToString(const std::wstring& wstr);
std::wstring ToWString(const std::string& str);

void chomp(std::string& str);
void chomp(char *str);
bool SplitString(const std::string& str, StringList& strlist, bool bWithEscape= true);
std::string JoinStringList(const StringList& strlist, const std::string& sep);

std::string stringformat(char *fmt, ...);

int stringicompare(const std::string& a, const std::string& b);
std::string tolower(const std::string& str);

#define stringptr(v)  (&(v)[0])

std::string hexdump(const ByteVector& buf, int nDumpUnitSize=1);
std::string hexdump(const BYTE *buf, int nLength, int nDumpUnitSize=1);
std::string hexdump(DWORD dwOffset, const BYTE *buf, int nLength, int nDumpUnitSize=1, int nMaxUnitsPerLine=16);

std::string ascdump(const ByteVector& buf, const std::string& escaped= "", bool bBreakOnEol= false);
std::string asciidump(const BYTE *buf, size_t bytelen);

#define __STRINGUTILS_H_
#endif
