#include <windows.h>

#include "kernelinfo.h"
#include "cenk.h"
#include "debug.h"
#include "itsutils.h"

// c:\local\wince300\PRIVATE/WINCEOS/COREOS/NK/INC/kernel.h
//
void GetProcessTimes_forver(DWORD pid, DWORD *ptKernel, DWORD *ptUser)
{
    HDATA *hdata= (HDATA *)(0x80000000+((DWORD)pid&0x1ffffffc));

    PROCESS *pproc= (PROCESS *)hdata->pvObj;

    DWORD tKernel=0;
    DWORD tUser=0;

    THREAD *pth= pproc->pTh;
    while(pth)
    {
        tKernel += pth->dwKernTime;
        tUser   += pth->dwUserTime;

        pth= pth->pNextInProc;
    }
}

const WCHAR *GetProcessCommandLine_forver(DWORD pid)
{
    HDATA *hdata= (HDATA *)(0x80000000+((DWORD)pid&0x1ffffffc));

    PROCESS *pproc= (PROCESS *)hdata->pvObj;

    return pproc->pcmdline;
}


void GetProcessUsageList_forver(GetProcessUsageListResult *pOut)
{
    DWORD pid=GetCurrentProcessId();

    HDATA *hi= (HDATA *)(0x80000000+((DWORD)pid&0x1ffffffc));

    HDATA *ha;

    ha=hi;
    do {
        if (ha->pci && ha->pci->acName && strncmp(ha->pci->acName, "THRD", 4)==0 && ha->pvObj)
        {
            THREAD *pt = (THREAD*)ha->pvObj;
            if (pt->pOwnerProc==NULL) {
                debug("ownerproc==NULL\n");
            }
            else if (pt->pOwnerProc->procnum>=MAX_PROCESSES || pt->pOwnerProc->procnum<0) {
                debug("!! procnum too large: %d\n", pt->pOwnerProc->procnum);
            }
            else {
                ProcSummaryInfo &ps= pOut->list[pt->pOwnerProc->procnum];
                ps.hProc= pt->pOwnerProc->hProc;
                ps.tKernel += pt->dwKernTime;
                ps.tUser   += pt->dwUserTime;
                ps.nThreads++;
            }
        }

        ha= (HDATA*)ha->linkage.fwd;
    } while (ha!=hi && ha!=NULL);
}
void GetThreadUsageList_forver(GetThreadUsageListResult *pOut)
{
    DWORD pid=GetCurrentProcessId();

    HDATA *hi= (HDATA *)(0x80000000+((DWORD)pid&0x1ffffffc));

    HDATA *ha;

    int threadnr= 0;
    ha=hi;
    do {
        if (ha->pci && ha->pci->acName && strncmp(ha->pci->acName, "THRD", 4)==0 && ha->pvObj)
        {
            THREAD *pt = (THREAD*)ha->pvObj;

            ThreadSummaryInfo &ts= pOut->list[threadnr++];

            if (pt->pOwnerProc==NULL) {
                debug("ownerproc==NULL\n");
            }
            else {
                ts.hProc   = pt->pOwnerProc->hProc;
            }
            ts.hThread = pt->hTh;
            ts.tKernel = pt->dwKernTime;
            ts.tUser   = pt->dwUserTime;
            ts.dwStartAddr= pt->dwStartAddr;

            FindModuleNameForProcessAddress((DWORD)ts.hProc, ts.dwStartAddr, ts.szModname, 255);

            ts.baseprio= pt->bBPrio;
            ts.curprio= pt->bCPrio;
        }
        ha= (HDATA*)ha->linkage.fwd;
    } while (ha!=hi && ha!=NULL &&  threadnr<MAX_THREADS);

    pOut->nThreads= threadnr;
}
