@echo off
mkdir ..\build 2>nul

call ..\local.bat

set cc=%cesdk%\bin\clarm.exe
set libtool=%cesdk%\bin\lib.exe
rem !!! do not name this variable 'link', it confuses the linker.
set ld=%cesdk%\bin\link.exe
set include=%ppcsdk%\include
set lib=%ppcsdk%\lib\arm


set pbincs=/I "%pbsrc2%\PRIVATE\WINCEOS\COREOS\NK\INC" /I "%pbsrc1%\PUBLIC\COMMON\OAK\INC" /I "%pbsrc1%\PUBLIC\COMMON\SDK\INC" /I ..\include /I ..\libril /I ..\common

rem /Zi /Od /Fd"../build/ce/" for debugging
rem /O2      for release
set cflags=/nologo /W3 /O2 /MC /c /Fo"../build/ce/" /I %stlevc% %pbincs% 
set targetdefs=/D "ARM" /D "_ARM_"
set platformdefs=/D _WIN32_WCE=300 /D "WIN32_PLATFORM_PSPC=310" /D UNDER_CE=300 /D "UNICODE" /D "_UNICODE"
set cdefs=/D "DEBUG" %targetdefs% %platformdefs%
set dlldefs=/D "_USRDLL"

"%libtool%" /def:..\libril\ril.def /out:..\build\ril.lib /machine:arm

"%cc%" %cflags% %cdefs% %dlldefs% /D "ITSUTILS_EXPORTS" ItsUtils.cpp
if errorlevel 1 goto end
"%cc%" %cflags% %cdefs% %dlldefs% ..\common\debug.cpp
if errorlevel 1 goto end
"%cc%" %cflags% %cdefs% %dlldefs% ..\common\stringutils.cpp
if errorlevel 1 goto end
"%cc%" %cflags% %cdefs% %dlldefs% gsmdevice.cpp
if errorlevel 1 goto end
"%cc%" %cflags% %cdefs% %dlldefs% /D "SPRAPIUTILS_EXPORTS" sprapiutils.cpp
if errorlevel 1 goto end

set lddllflags=/entry:"_DllMainCRTStartup" /dll 
set ldexeflags=/entry:"WinMainCRTStartup"
set ldplatformflags=/subsystem:windowsce,3.00 /align:"4096" 
set ldtargetflags=/MACHINE:ARM 
set ldflags=/nologo /base:"0x00100000" /stack:0x10000,0x1000 %ldtargetflags% %ldplatformflags%

set nodeflib=/nodefaultlib:libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib /nodefaultlib:oldnames.lib

set extralibs=toolhelp.lib 

rem /pdb:"../build/itsutils.pdb" /debug  

"%ld%" %ldflags% %extralibs% %nodeflib% %lddllflags% /out:"../build/itsutils.dll" /implib:"../build/ce/itsutils.lib" "../build/ce\itsutils.obj" "../build/ce\gsmdevice.obj" "../build/ce\debug.obj" "../build/ce\stringutils.obj" "../build/ce/ril.lib"
if errorlevel 1 goto end
"%ld%" %ldflags% %extralibs% %nodeflib% %lddllflags% /out:"../build/sprapiutils.dll" /implib:"../build/ce/sprapiutils.lib" "../build/ce\sprapiutils.obj"
if errorlevel 1 goto end

:end

