/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/lib/cvs/nah6utils/leds/ledtest.cpp,v 1.3 2004/01/05 18:01:47 itsme Exp $
 */
#include  <windows.h>
#include  <nled.h>
#include  <Pwinuser.h>
#include "debug.h"

void LedOn(int id)
{
    NLED_SETTINGS_INFO settings; memset(&settings, 0, sizeof(settings));
    settings.LedNum= id;
    settings.OffOnBlink= 1;
    if (!NLedSetDevice(NLED_SETTINGS_INFO_ID, &settings))
        error("NLedSetDevice(NLED_SETTINGS_INFO_ID )");
}
void LedBlink(int id, int onMsec, int offMsec)
{
    NLED_SETTINGS_INFO settings; memset(&settings, 0, sizeof(settings));
    settings.LedNum= id;
    settings.OffOnBlink= 2;
    settings.OnTime= 1000*onMsec;
    settings.OffTime= 1000*offMsec;
    settings.TotalCycleTime= settings.OnTime+settings.OffTime;
    settings.MetaCycleOn = 1;
    settings.MetaCycleOff = 0;
    if (!NLedSetDevice(NLED_SETTINGS_INFO_ID, &settings))
        error("NLedSetDevice(NLED_SETTINGS_INFO_ID )");
}
void LedMetaBlink(int id, int onMsec, int offMsec, int onCycles, int offCycles)
{
    NLED_SETTINGS_INFO settings; memset(&settings, 0, sizeof(settings));
    settings.LedNum= id;
    settings.OffOnBlink= 2;
    settings.OnTime= 1000*onMsec;
    settings.OffTime= 1000*offMsec;
    settings.TotalCycleTime= settings.OnTime+settings.OffTime;
    settings.MetaCycleOn = onCycles;
    settings.MetaCycleOff = offCycles;
    if (!NLedSetDevice(NLED_SETTINGS_INFO_ID, &settings))
        error("NLedSetDevice(NLED_SETTINGS_INFO_ID )");
}
void LedOff(int id)
{
    NLED_SETTINGS_INFO settings; memset(&settings, 0, sizeof(settings));
    settings.LedNum= id;
    settings.OffOnBlink= 0;
    if (!NLedSetDevice(NLED_SETTINGS_INFO_ID, &settings))
        error("NLedSetDevice(NLED_SETTINGS_INFO_ID )");
}
int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("\\ledtest.log");
/*
    NLED_COUNT_INFO count; memset(&count, 0, sizeof(count));
    if (!NLedGetDeviceInfo(NLED_COUNT_INFO_ID, &count))
        error("NLedGetDeviceInfo(NLED_COUNT_INFO_ID)");
    debug("ledcount=%d\n", count.cLeds);

    for (int i=0 ; i<count.cLeds ; i++)
    {
        NLED_SUPPORTS_INFO supports; memset(&supports, 0, sizeof(supports));
        supports.LedNum= i;
        if (!NLedGetDeviceInfo(NLED_SUPPORTS_INFO_ID , &supports))
            error("NLedGetDeviceInfo(NLED_SUPPORTS_INFO_ID)");

        debug("%d : cycletime=%d us  ontime=%d offtime=%d metaon=%d metaoff=%d\n",
                supports.LedNum, supports.lCycleAdjust,
                supports.fAdjustTotalCycleTime, supports.fAdjustOnTime,
                supports.fAdjustOffTime, supports.fMetaCycleOn,
                supports.fMetaCycleOff);

        NLED_SETTINGS_INFO settings; memset(&settings, 0, sizeof(settings));
        settings.LedNum= i;
        if (!NLedGetDeviceInfo(NLED_SETTINGS_INFO_ID , &settings))
            error("NLedGetDeviceInfo(NLED_SETTINGS_INFO_ID )");
        debug("%d : oob=%d cycle=%d us, on=%d us, off=%d us, metaon=%d metaoff=%d\n",
                settings.LedNum, settings.OffOnBlink,
                settings.TotalCycleTime, settings.OnTime, settings.OffTime,
                settings.MetaCycleOn, settings.MetaCycleOff);

        settings.OffOnBlink= 0;
        settings.TotalCycleTime= 500000;
        settings.OnTime= 100000;
        settings.OffTime= 100000;
        settings.MetaCycleOn = 1;
        settings.MetaCycleOff = 0;
        if (!NLedSetDevice(NLED_SETTINGS_INFO_ID, &settings))
            error("NLedSetDevice(NLED_SETTINGS_INFO_ID )");
    }
*/
/*
    LedBlink(0, 100, 500);
    Sleep(5000);
    LedMetaBlink(0, 100, 100, 3, 8);
    Sleep(5000);

    LedOn(0);
    Sleep(5000);

    LedOff(0);
    Sleep(1000);
    LedOn(1);
    Sleep(1000);
    LedBlink(1, 100, 100);
    Sleep(1000);
    LedMetaBlink(1, 100, 100, 2, 5);
    Sleep(1000);
    LedOn(1); Sleep(500); LedOff(1); Sleep(100);
*/
    LARGE_INTEGER pc1, pc2, f;
    QueryPerformanceFrequency(&f);
    debug("f=%08lx%08lx\n", f.HighPart, f.LowPart);

    DWORD x;
    for (int i=0 ; i<100000 ; i++)
    {
        QueryPerformanceCounter(&pc1);
        QueryPerformanceCounter(&pc2);
        if (pc1.HighPart==pc2.HighPart)
            x+= pc2.LowPart-pc1.LowPart;
        else
            x-= pc2.LowPart-pc1.LowPart;
    }
    debug("%d / 100000 usec per call\n", x);

    LedMetaBlink(1, 200, 200, 4, 10);
    Sleep(200);
    LedOff(1);

    return 0;
}
