#include <windows.h>
#include "debug.h"

extern "C" void do_tst();
extern "C" void do_tst1();
extern "C" void do_tst2();
extern "C" void do_tst3();
extern "C" KernelIoControl(DWORD dwCode, void *in, DWORD insize, void *out, DWORD outsize, DWORD *returned);

bool set_cpu_speed(DWORD dwSpeed)
{
    DWORD nReturned;
    if (!KernelIoControl(0x01012088, &dwSpeed, sizeof(DWORD), 0, 0, &nReturned)) {
        error("KernelIoControl(0x01012088, %d)\n", dwSpeed);
        return false;
    }
    return true;
}

void run_cpu_test()
{
    DWORD t0= GetTickCount();
    do_tst();
    DWORD t1= GetTickCount();
    do_tst1();
    DWORD t2= GetTickCount();
    do_tst2();
    DWORD t3= GetTickCount();
    do_tst3();
    DWORD t4= GetTickCount();

    debug("took %d %d %d %d msecs\n", t1-t0, t2-t1, t3-t2, t4-t3);
    double timediffsum = t0 -t1 -t3 +t4;
    debug("%5.2f Mhz\n", 1024.0*1024.0*1024.0/ (timediffsum /3.0) / 1000);
}
int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("\\tstcpu.log");

    debug("initial\n");
    run_cpu_test();
/*
    set_cpu_speed(0);
    debug("set_cpu_speed(0)\n");
    run_cpu_test();
    set_cpu_speed(1);
    debug("set_cpu_speed(1)\n");
    run_cpu_test();
    set_cpu_speed(0);
    debug("set_cpu_speed(0)\n");
    run_cpu_test();
    set_cpu_speed(1);
    debug("set_cpu_speed(1)\n");
    run_cpu_test();
    set_cpu_speed(0);
    debug("set_cpu_speed(0)\n");
    run_cpu_test();
*/
    return 0;
}
