/* (C) 2003 XDA Developers  itsme@xs4all.nl
 * Copyright 2001,2002,2003 NAH6 BV
 * All Rights Reserved
 * 
 * $Header: /var/lib/cvs/xdautils/rilhook/RilClass.h,v 1.7 2004/05/03 08:26:16 itsme Exp $
 */

#ifndef __RILCLASS_H__

#include "ril.h"

#define RIL_NOTIFY_CELLID       (0x00000003 | RIL_NCLASS_DEVSPECIFIC)

typedef struct {
	DWORD lac;
	DWORD cellid;
} RILCELLID;



class RilClass {
public:
    RilClass();
    ~RilClass();

    bool open(DWORD dwIndex);
    bool close();

    void GetDriverInfo();

    void HandleResult(DWORD dwCode, HRESULT hrCmdID, const void *lpData, DWORD cbdata);
    void HandleNotify(DWORD dwCode, const void *lpData, DWORD cbdata);

    void HandleSignalQualityAnswer(RILSIGNALQUALITY *sq);
    void HandleEquipmentInfoAnswer(RILEQUIPMENTINFO* info);
    void HandleSignalQualityError(DWORD dwRilError);
    void HandleLockedStateAnswer(DWORD dwLockedState);
	void HandleCallListAnswer(RILCALLINFO* cilist, int ncalls);

    void HandleRadioStateChanged(RILEQUIPMENTSTATE* es, DWORD cbdata);
    void HandleNetworkRegistrationStatusChanged(DWORD* d, DWORD cbdata);;

    void HandleSimRecordStatusAnswer(RILSIMRECORDSTATUS *sq, DWORD dwSize);
    void HandleEquipmentStateAnswer(RILEQUIPMENTSTATE* state);
    void HandleCurrentAddressIdAnswer(DWORD dwId);
    void HandleAudioMutingAnswer(BOOL bMuted);
    void HandleSubscriberNumbersAnswer(RILSUBSCRIBERINFO *pInfo, int n);
    void HandleAudioDevicesAnswer(RILAUDIODEVICEINFO* devinfo);
	void HandleCellIdMessage(RILCELLID *cellid);

	bool RequestSignalQuality();
	bool RequestSimRecordStatus(DWORD dwFileId);
    bool RequestEquipmentInfo();
    bool RequestEquipmentState();
    bool RequestCurrentAddressId();
	bool RequestCallList();
    bool RequestAudioMuting();
    bool RequestSubscriberNumbers();
    bool RequestLockedState();
	bool SetAudioMuting(bool bFlag);
    bool RequestAudioDevices();
    bool EnableCellId(bool bFlag);
	bool EnableCellBroadcasts(bool bFlag);
    bool SetEqState(DWORD dwState);

private:
    HRIL m_hRil;

    HRESULT m_hrCallListRequest;
    HRESULT m_hrEquipmentInfoRq;
    HRESULT m_hrEquipmentStateRequest;
    HRESULT m_hrCurrentAddressIdRequest;
    HRESULT m_hrSignalQualityRequest;
    HRESULT m_hrSimRecordStatusRequest;
    HRESULT m_hrAudioDevicesRequest;
    HRESULT m_hrAudioMutingRequest;
    HRESULT m_hrSubscriberNumbersRequest;
    HRESULT m_hrLockedStateRequest;
	HRESULT m_hrSetAudioMutingRequest;

    HRESULT m_hrCBSRequest;
	HRESULT m_hrCellIdRequest;

    static void ResultProc(DWORD dwCode, HRESULT hrCmdID, const void *lpData, DWORD cbdata, DWORD dwParam);
    static void NotifyProc(DWORD dwCode, const void *lpData, DWORD cbdata, DWORD dwParam);
};

#define __RILCLASS_H__
#endif

